#!/usr/bin/python3
# coding: utf-8

### const_var.py: define constants and variables

### import libraries
from PyQt5.QtGui import QFont

### set constants
grism_names = ['VPH-blue', 'VPH-red', 'VPH495', 'VPH683']
comp_names = ['Hg', 'Ne', 'Xe']
frameNameChoices = ['kif%08d.fits', 'kls%08d.fits']

bias_comb = 'lib/bias-comb.fits'

n_fiber_dict = {'2014': 127, '2019': 117}
n_pixel = (1640, 2048) # after cutting overscan regions

plot_shift = 0.5

fiber_pos_2d_dict = {'2014':(
  (0, 0, 0, 0, 0, 0, 104, 0, 29, 0, 16, 0, 31, 0, 15, 0, 28, 0, 4, 0, 0, 0, 0, 0, 0),
  (0, 0, 0, 0, 0, 103, 0, 115, 0, 90, 0, 101, 0, 7, 0, 1, 0, 42, 0, 40, 0, 0, 0, 0, 0),
  (0, 0, 0, 0, 89, 0, 38, 0, 119, 0, 10, 0, 24, 0, 17, 0, 41, 0, 33, 0, 62, 0, 0, 0, 0),
  (0, 0, 0, 102, 0, 93, 0, 5, 0, 126, 0, 8, 0, 36, 0, 25, 0, 20, 0, 106, 0, 2, 0, 0, 0),
  (0, 0, 109, 0, 113, 0, 87, 0, 88, 0, 21, 0, 121, 0, 11, 0, 32, 0, 14, 0, 95, 0, 69, 0, 0),
  (0, 127, 0, 114, 0, 124, 0, 111, 0, 30, 0, 34, 0, 122, 0, 35, 0, 3, 0, 64, 0, 75, 0, 65, 0),
  (99, 0, 97, 0, 98, 0, 92, 0, 23, 0, 12, 0, 37, 0, 39, 0, 26, 0, 63, 0, 83, 0, 73, 0, 59),
  (0, 96, 0, 117, 0, 108, 0, 9, 0, 91, 0, 120, 0, 27, 0, 71, 0, 68, 0, 116, 0, 82, 0, 72, 0),
  (0, 0, 123, 0, 107, 0, 18, 0, 86, 0, 13, 0, 70, 0, 84, 0, 85, 0, 51, 0, 57, 0, 79, 0, 0),
  (0, 0, 0, 110, 0, 112, 0, 19, 0, 105, 0, 125, 0, 74, 0, 58, 0, 77, 0, 56, 0, 47, 0, 0, 0),
  (0, 0, 0, 0, 48, 0, 94, 0, 100, 0, 6, 0, 78, 0, 81, 0, 60, 0, 52, 0, 67, 0, 0, 0, 0),
  (0, 0, 0, 0, 0, 49, 0, 118, 0, 22, 0, 53, 0, 45, 0, 44, 0, 76, 0, 66, 0, 0, 0, 0, 0),
  (0, 0, 0, 0, 0, 0, 54, 0, 46, 0, 80, 0, 61, 0, 50, 0, 55, 0, 43, 0, 0 ,0, 0, 0, 0)),
#  '2019':(
#  (  0,  86,   0,   9,   0,  11,   0,  33,   0,   5,   0,   7,   0, 117,   0, 111,   0, 107,   0, 108,   0,   0,   0,   0,   0,   0),
#  (  2,   0,  24,   0,  36,   0,  15,   0,  35,   0,  38,   0,  32,   0,  12,   0, 112,   0,  10,   0,   0,   0,   0,   0,   0,   0),
#  (  0,  87,   0,  43,   0,  21,   0,  13,   0,  28,   0,  34,   0,  39,   0,   8,   0,  17,   0,  25,   0,   0,   0,   0,   0,   0),
#  ( 23,   0,  66,   0,  50,   0,  46,   0,  56,   0,   1,   0,  41,   0,  19,   0,  37,   0,  22,   0,   0,   0,   0,   0,   0,   0),
#  (  0,  62,   0,  77,   0,  55,   0,  71,   0,  67,   0,   4,   0,  63,   0,  76,   0,  54,   0,  31,   0,   0,  80,   0,  85,   0),
#  ( 99,   0,  78,   0,  68,   0, 109,   0,  74,   0, 115,   0,  75,   0,  70,   0,  53,   0,  42,   0,   0,  82,   0,  81,   0,  84),
#  (  0,  96,   0,  58,   0,  44,   0,  51,   0,  64,   0, 106,   0,  57,   0, 105,   0,  61,   0,  73,   0,   0,  83,   0,  79,   0),
#  (100,   0, 110,   0, 104,   0,  92,   0,  72,   0,  59,   0,  52,   0, 114,   0,  98,   0,  45,   0,   0,   0,   0,   0,   0,   0),
#  (  0,  48,   0,  29,   0,  89,   0,  94,   0,  91,   0,  30,   0,  97,   0,  69,   0,  49,   0,  40,   0,   0,   0,   0,   0,   0),
#  ( 16,   0,  95,   0,  60,   0,  65,   0,  27,   0,  47,   0,  18,   0,  20,   0, 103,   0,  88,   0,   0,   0,   0,   0,   0,   0),
#  (  0,  93,   0, 101,   0, 113,   0, 102,   0,  90,   0,  14,   0, 116,   0,   6,   0,   3,   0,  26,   0,   0,   0,   0,   0,   0)),
  '2019':(
  (  0,  86,   0,   9,   0,  11,   0,  33,   0,   5,   0,   7,   0, 117,   0, 111,   0, 107,   0, 108,   0,   0,   0,   0,   0,   0,   0,   0),
  (  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0),
  (  2,   0,  24,   0,  36,   0,  15,   0,  35,   0,  38,   0,  32,   0,  12,   0, 112,   0,  10,   0,   0,   0,   0,   0,   0,   0,   0,   0),
  (  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0),
  (  0,  87,   0,  43,   0,  21,   0,  13,   0,  28,   0,  34,   0,  39,   0,   8,   0,  17,   0,  25,   0,   0,   0,   0,   0,   0,   0,   0),
  (  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0),
  ( 23,   0,  66,   0,  50,   0,  46,   0,  56,   0,   1,   0,  41,   0,  19,   0,  37,   0,  22,   0,   0,   0,   0,   0,   0,   0,   0,   0),
  (  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0),
  (  0,  62,   0,  77,   0,  55,   0,  71,   0,  67,   0,   4,   0,  63,   0,  76,   0,  54,   0,  31,   0,   0,   0,  80,   0,  85,   0,   0),
  (  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0),
  ( 99,   0,  78,   0,  68,   0, 109,   0,  74,   0, 115,   0,  75,   0,  70,   0,  53,   0,  42,   0,   0,   0,  82,   0,  81,   0,  84,   0),
  (  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0),
  (  0,  96,   0,  58,   0,  44,   0,  51,   0,  64,   0, 106,   0,  57,   0, 105,   0,  61,   0,  73,   0,   0,   0,  83,   0,  79,   0,   0),
  (  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0),
  (100,   0, 110,   0, 104,   0,  92,   0,  72,   0,  59,   0,  52,   0, 114,   0,  98,   0,  45,   0,   0,   0,   0,   0,   0,   0,   0,   0),
  (  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0),
  (  0,  48,   0,  29,   0,  89,   0,  94,   0,  91,   0,  30,   0,  97,   0,  69,   0,  49,   0,  40,   0,   0,   0,   0,   0,   0,   0,   0),
  (  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0),
  ( 16,   0,  95,   0,  60,   0,  65,   0,  27,   0,  47,   0,  18,   0,  20,   0, 103,   0,  88,   0,   0,   0,   0,   0,   0,   0,   0,   0),
  (  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0),
  (  0,  93,   0, 101,   0, 113,   0, 102,   0,  90,   0,  14,   0, 116,   0,   6,   0,   3,   0,  26,   0,   0,   0,   0,   0,   0,   0,   0),
  (  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0)) }

fiber_pos_x_dict = {'2014':(
  16, 22, 18, 19,  8, 11, 14, 12,  8, 11,
  15, 11, 11, 19, 15, 11, 15,  7,  8, 18,
  11, 10,  9, 13, 16, 17, 14, 17,  9, 10,
  13, 17, 19, 12, 16, 14, 13,  7, 15, 20,
  17, 18, 19, 16, 14,  9, 22,  5,  6, 15,
  19, 19, 12,  7, 17, 20, 21, 16, 25, 17,
  13, 21, 19, 20, 24, 20, 21, 18, 23, 13,
  16, 24, 23, 14, 22, 18, 18, 13, 23, 11,
  15, 22, 21, 15, 17,  9,  7,  9,  5, 10,
  10,  7,  6,  7, 21,  2,  3,  5,  1,  9,
  12,  4,  6,  7, 10, 20,  5,  6,  3,  4,
   8,  6,  5,  4,  8, 20,  4,  8,  9, 12,
  13, 14,  3,  6, 12, 10,  2),
  '2019':(
  11,  1, 18, 12, 10, 16, 12, 16,  4, 19, #  0
   6, 15,  8, 12,  7,  1, 18, 13, 15, 15, # 10
   6, 19,  1,  3, 20, 20,  9, 10,  4, 12, # 20
  20, 13,  8, 12,  9,  5, 17, 11, 14, 20, # 30
  13, 19,  4,  6, 19,  7, 11,  2, 18,  5, # 40
   8, 13, 17, 18,  6,  9, 14,  4, 11,  5, # 50
  18,  2, 14, 10,  7,  3, 10,  5, 16, 15, # 60
   8,  9, 20,  9, 13, 16,  4,  3, 26, 24, # 70
  25, 23, 24, 27, 26,  2,  2, 19,  6, 10, # 80
  10,  7,  2,  8,  3,  2, 14, 17,  1,  1, # 90
   4,  8, 17,  5, 16, 12, 18, 20,  7,  3, #100
  16, 17,  6, 15, 11, 14, 14) }

fiber_pos_y_dict = {'2014':(
  23, 19, 15, 25, 19,  5, 23, 19, 11, 21,
  17, 13,  9, 17, 25, 25, 21,  9,  7, 19,
  17,  3, 13, 21, 19, 13, 11, 25, 25, 15,
  25, 17, 21, 15, 15, 19, 13, 21, 13, 23,
  21, 23,  1,  3,  3,  1,  7,  5,  3,  1,
   9,  5,  3,  1,  1,  7,  9,  7, 13,  5,
   1, 21, 13, 15, 15,  3,  5, 11, 17,  9,
  11, 11, 13,  7, 15,  3,  7,  5,  9,  1,
   5, 11, 13,  9,  9,  9, 17, 17, 21, 23,
  11, 13, 19,  5, 17, 11, 13, 13, 13,  5,
  23, 19, 23, 25,  7, 19,  9, 11, 17,  7,
  15,  7, 17, 15, 23, 11, 11,  3, 21, 11,
  17, 15,  9, 15,  7, 19, 15),
  '2019':(
   7,  3, 21,  9,  1, 21,  1,  5,  1,  3,
   1,  3,  5, 21,  3, 19,  5, 19,  7, 19,
   5,  7,  7,  3,  5, 21, 19,  5, 17, 17,
   9,  3,  1,  5,  3,  3,  7,  3,  5, 17,
   7, 11,  5, 13, 15,  7, 19, 17, 17,  7,
  13, 15, 11,  9,  9,  7, 13, 13, 15, 19,
  13,  9,  9, 13, 19,  7,  9, 11, 17, 11,
   9, 15, 13, 11, 11,  9,  9, 11, 13,  9,
  11, 11, 13, 11,  9,  1,  5, 19, 17, 21,
  17, 15, 21, 17, 19, 13, 17, 15, 11, 15,
  21, 21, 19, 15, 13, 13,  1,  1, 11, 15,
   1,  3, 21, 15, 11, 21,  1)}

# define font
fontLabel = QFont()
fontLabel.setPixelSize(28)
font = QFont()
font.setPixelSize(20)
fontToolTip = QFont()
fontToolTip.setPixelSize(16)

### define variables
cpuThreadLimit = 4
frameOverwrite = 'No'

frameTable = []
frameFormat = frameNameChoices[0]

frames = {'bias': [], 'no_grism': []}
frames['flat'] = [[] for i in range(len(grism_names))]
frames['Hg'] = [[] for i in range(len(grism_names))]
frames['Ne'] = [[] for i in range(len(grism_names))]
frames['Xe'] = [[] for i in range(len(grism_names))]
frames['sstar'] = [[] for i in range(len(grism_names))]
frames['twilight'] = [[] for i in range(len(grism_names))]
frames['object'] = [[] for i in range(len(grism_names))]

skip_fiber_list = []
